"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeTag = exports.PreTag = exports.generateNewStylesheet = void 0;
/**
 * This code is based on:
 * https://github.com/conorhastings/react-native-syntax-highlighter
 */
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_syntax_highlighter_1 = require("react-syntax-highlighter");
var react_syntax_highlighter_2 = __importDefault(require("react-syntax-highlighter"));
var prismStyles = __importStar(require("react-syntax-highlighter/dist/esm/styles/prism"));
var hljsStyles = __importStar(require("react-syntax-highlighter/dist/esm/styles/hljs"));
var react_native_gesture_handler_1 = require("react-native-gesture-handler");
var utils_1 = require("./utils");
var styes_1 = __importDefault(require("./styes"));
var styleCache = new Map();
var topLevelPropertiesToRemove = [
    "color",
    "textShadow",
    "textAlign",
    "whiteSpace",
    "wordSpacing",
    "wordBreak",
    "wordWrap",
    "lineHeight",
    "MozTabSize",
    "OTabSize",
    "tabSize",
    "WebkitHyphens",
    "MozHyphens",
    "msHyphens",
    "hyphens",
    "fontFamily",
];
/**
 * TODO: improve types
 */
function generateNewStylesheet(_a) {
    var stylesheet = _a.stylesheet, highlighter = _a.highlighter;
    if (styleCache.has(stylesheet)) {
        return styleCache.get(stylesheet);
    }
    stylesheet = Array.isArray(stylesheet) ? stylesheet[0] : stylesheet;
    var transformedStyle = Object.entries(stylesheet).reduce(function (newStylesheet, _a) {
        var className = _a[0], style = _a[1];
        newStylesheet[className] = Object.entries(style).reduce(function (newStyle, _a) {
            var key = _a[0], value = _a[1];
            if (key === "overflowX" || key === "overflow") {
                newStyle.overflow = value === "auto" ? "scroll" : value;
            }
            else if (value.includes("em")) {
                var num = value.split("em")[0];
                newStyle[key] = Number(num) * 16;
            }
            else if (key === "background") {
                newStyle.backgroundColor = value;
            }
            else if (key === "display") {
                return newStyle;
            }
            else {
                newStyle[key] = value;
            }
            return newStyle;
        }, {});
        return newStylesheet;
    }, {});
    var topLevel = highlighter === "prism"
        ? transformedStyle['pre[class*="language-"]']
        : transformedStyle.hljs;
    var defaultColor = (topLevel && topLevel.color) || "#000";
    topLevelPropertiesToRemove.forEach(function (property) {
        if (topLevel[property]) {
            delete topLevel[property];
        }
    });
    if (topLevel.backgroundColor === "none") {
        delete topLevel.backgroundColor;
    }
    var codeLevel = transformedStyle['code[class*="language-"]'];
    if (highlighter === "prism" && !!codeLevel) {
        topLevelPropertiesToRemove.forEach(function (property) {
            if (codeLevel[property]) {
                delete codeLevel[property];
            }
        });
        if (codeLevel.backgroundColor === "none") {
            delete codeLevel.backgroundColor;
        }
    }
    styleCache.set(stylesheet, { transformedStyle: transformedStyle, defaultColor: defaultColor });
    return { transformedStyle: transformedStyle, defaultColor: defaultColor };
}
exports.generateNewStylesheet = generateNewStylesheet;
function createChildren(_a) {
    var stylesheet = _a.stylesheet, fontSize = _a.fontSize, fontFamily = _a.fontFamily;
    var childrenCount = 0;
    return function (children, defaultColor) {
        childrenCount += 1;
        return children.map(function (child, i) {
            return createNativeElement({
                node: child,
                stylesheet: stylesheet,
                key: "code-segment-" + childrenCount + "-" + i,
                defaultColor: defaultColor,
                fontSize: fontSize,
                fontFamily: fontFamily,
            });
        });
    };
}
function createNativeElement(_a) {
    var node = _a.node, stylesheet = _a.stylesheet, key = _a.key, defaultColor = _a.defaultColor, fontFamily = _a.fontFamily, _b = _a.fontSize, fontSize = _b === void 0 ? 12 : _b;
    var properties = node.properties, type = node.type, TagName = node.tagName, value = node.value;
    var startingStyle = { fontFamily: fontFamily, fontSize: fontSize, height: fontSize + 5 };
    if (type === "text") {
        return (<react_native_1.Text key={key} style={Object.assign({ color: defaultColor }, startingStyle)}>
        {value}
      </react_native_1.Text>);
    }
    else if (TagName) {
        var childrenCreator = createChildren({
            stylesheet: stylesheet,
            fontSize: fontSize,
            fontFamily: fontFamily,
        });
        var style = utils_1.createStyleObject(properties.className, Object.assign({ color: defaultColor }, properties.style, startingStyle), stylesheet);
        var children = childrenCreator(node.children, style.color || defaultColor);
        return (<react_native_1.Text key={key} style={style}>
        {children}
      </react_native_1.Text>);
    }
}
function nativeRenderer(_a) {
    var defaultColor = _a.defaultColor, fontFamily = _a.fontFamily, fontSize = _a.fontSize, dark = _a.dark, startingLineNumber = _a.startingLineNumber;
    return function (_a) {
        var rows = _a.rows, stylesheet = _a.stylesheet;
        var width = Math.floor(Math.log10(rows.length)) * fontSize * 1.75;
        return rows.map(function (node, i) {
            return (<react_native_1.View key={"row-wrapper" + (i + startingLineNumber)} style={styes_1.default.row_container}>
          <react_native_1.View style={[
                styes_1.default.number_container,
                {
                    width: width,
                    backgroundColor: dark ? "#000" : "#fff",
                },
            ]}>
            <react_native_1.Text style={[
                styes_1.default.number,
                {
                    color: dark ? "#fff" : "#000",
                    fontSize: fontSize,
                },
            ]}>
              {"" + (i + startingLineNumber)}
            </react_native_1.Text>
          </react_native_1.View>
          <react_native_1.View style={[
                styes_1.default.text_container,
                {
                    paddingLeft: width + 4,
                },
            ]}>
            <react_native_1.Text>
              {createNativeElement({
                node: node,
                stylesheet: stylesheet,
                key: "code-segment-" + i,
                defaultColor: defaultColor,
                fontFamily: fontFamily,
                fontSize: fontSize,
            })}
            </react_native_1.Text>
          </react_native_1.View>
        </react_native_1.View>);
        });
    };
}
exports.PreTag = function (props) {
    return (<react_native_gesture_handler_1.ScrollView {...props} horizontal={true} contentContainerStyle={styes_1.default.pretag}/>);
};
exports.CodeTag = function (props) {
    return (<react_native_gesture_handler_1.ScrollView {...props} horizontal={false} contentContainerStyle={styes_1.default.codetag}/>);
};
var fontFamilyDef = react_native_1.Platform.OS == "ios" ? "Menlo-Regular" : "monospace";
var fontSizeDef = 12;
var prismDefaultStyle = prismStyles.atomDark;
var defaultStyle = hljsStyles.agate;
var RNSyntaxHighlighter = function (_a) {
    var _b = _a.fontFamily, fontFamily = _b === void 0 ? fontFamilyDef : _b, _c = _a.fontSize, fontSize = _c === void 0 ? fontSizeDef : _c, children = _a.children, _d = _a.dark, dark = _d === void 0 ? true : _d, _e = _a.highlighter, highlighter = _e === void 0 ? "highlighterjs" : _e, _f = _a.style, style = _f === void 0 ? highlighter === "prism" ? prismDefaultStyle : defaultStyle : _f, _g = _a.startingLineNumber, startingLineNumber = _g === void 0 ? 1 : _g, rest = __rest(_a, ["fontFamily", "fontSize", "children", "dark", "highlighter", "style", "startingLineNumber"]);
    var _h = react_1.useMemo(function () {
        return generateNewStylesheet({
            stylesheet: style,
            highlighter: highlighter,
        });
    }, [style, highlighter]), transformedStyle = _h.transformedStyle, defaultColor = _h.defaultColor;
    var Highlighter = react_1.useMemo(function () { return (highlighter === "prism" ? react_syntax_highlighter_1.Prism : react_syntax_highlighter_2.default); }, [highlighter]);
    var renderer = react_1.useMemo(function () {
        return nativeRenderer({
            defaultColor: defaultColor,
            fontFamily: fontFamily,
            fontSize: fontSize,
            dark: dark,
            startingLineNumber: startingLineNumber,
        });
    }, [defaultColor, fontFamily, fontSize, dark, startingLineNumber]);
    return (<Highlighter {...rest} PreTag={exports.PreTag} CodeTag={exports.CodeTag} style={transformedStyle} showLineNumbers={false} showInlineLineNumbers={false} wrapLines={true} horizontal={true} renderer={renderer}>
      {children}
    </Highlighter>);
};
exports.default = react_1.default.memo(RNSyntaxHighlighter);
//# sourceMappingURL=RNSyntaxHighlighter.js.map